org.apache.myfaces.trinidad.logging

## Class TrinidadLogger

- java.lang.Object
- - org.apache.myfaces.trinidad.logging.TrinidadLogger

-     public class TrinidadLogger
      extends Object

  TrinidadLogger wraps JDK 1.4 logging to provided a large number of extra convenience methods. TrinidadLoggers are created off of Packages or Classes (not arbitrary names) to force proper logging hierarchies.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addHandler(Handler handler)` Add a log Handler to receive logging messages.
    `void` | `config(String msg)` Log a CONFIG message.
    `void` | `config(String sourceClass, String sourceMethod, String msg)` Log a CONFIG message, with no arguments.
    `void` | `config(String sourceClass, String sourceMethod, String msg, Object param1)` Log a CONFIG message, with one object parameter.
    `void` | `config(String sourceClass, String sourceMethod, String msg, Object[] params)` Log a CONFIG message, with an array of object arguments.
    `static TrinidadLogger` | `createTrinidadLogger(Class<?> c)` Find or create a logger for a named subsystem.
    `static TrinidadLogger` | `createTrinidadLogger(Class<?> c, String resourceBundleName)` Find or create a logger for a named subsystem.
    `static TrinidadLogger` | `createTrinidadLogger(Package p)` Find or create a logger for a named subsystem.
    `static TrinidadLogger` | `createTrinidadLogger(Package p, String resourceBundleName)` Find or create a logger for a named subsystem.
    `void` | `entering(String sourceClass, String sourceMethod)` Log a method entry.
    `void` | `entering(String sourceClass, String sourceMethod, Object param1)` Log a method entry, with one parameter.
    `void` | `entering(String sourceClass, String sourceMethod, Object[] params)` Log a method entry, with an array of parameters.
    `void` | `exiting(String sourceClass, String sourceMethod)` Log a method return.
    `void` | `exiting(String sourceClass, String sourceMethod, Object result)` Log a method return, with result object.
    `void` | `fine(String msg)` Log a FINE message.
    `void` | `fine(String message, Object param)`
    `void` | `fine(String message, Object[] params)`
    `void` | `fine(String sourceClass, String sourceMethod, String msg)` Log a FINE message, with no arguments.
    `void` | `fine(String sourceClass, String sourceMethod, String msg, Object param1)` Log a FINE message, with one object parameter.
    `void` | `fine(String sourceClass, String sourceMethod, String msg, Object[] params)` Log a FINE message, with an array of object arguments.
    `void` | `fine(String message, Throwable t)`
    `void` | `fine(Throwable t)`
    `void` | `finer(String msg)` Log a FINER message.
    `void` | `finer(String message, Object param)`
    `void` | `finer(String message, Object[] params)`
    `void` | `finer(String sourceClass, String sourceMethod, String msg)` Log a FINER message, with no arguments.
    `void` | `finer(String sourceClass, String sourceMethod, String msg, Object param1)` Log a FINER message, with one object parameter.
    `void` | `finer(String sourceClass, String sourceMethod, String msg, Object[] params)` Log a FINER message, with an array of object arguments.
    `void` | `finer(String message, Throwable t)`
    `void` | `finer(Throwable t)`
    `void` | `finest(String msg)` Log a FINEST message.
    `void` | `finest(String message, Object param)`
    `void` | `finest(String message, Object[] params)`
    `void` | `finest(String sourceClass, String sourceMethod, String msg)` Log a FINEST message, with no arguments.
    `void` | `finest(String sourceClass, String sourceMethod, String msg, Object param1)` Log a FINEST message, with one object parameter.
    `void` | `finest(String sourceClass, String sourceMethod, String msg, Object[] params)` Log a FINEST message, with an array of object arguments.
    `void` | `finest(String message, Throwable t)`
    `void` | `finest(Throwable t)`
    `static TrinidadLogger` | `getAnonymousLogger()` Create an anonymous Logger.
    `static TrinidadLogger` | `getAnonymousLogger(String resourceBundleName)` Create an anonymous Logger.
    `Handler[]` | `getHandlers()` Get the Handlers associated with this logger.
    `Level` | `getLevel()` Get the log Level that has been specified for this Logger.
    `Logger` | `getLogger()` Get the Java logger from an Trinidad Logger.
    `String` | `getMessage(String key)` Returns message string in default locale
    `String` | `getMessage(String key, Object param)` Returns formated string in default locale
    `String` | `getMessage(String key, Object[] params)` Returns formated string in default locale
    `String` | `getName()` Get the name for this logger.
    `Logger` | `getParent()` Return the parent for this Logger.
    `boolean` | `getUseParentHandlers()` Discover whether or not this logger is sending its output to its parent logger.
    `void` | `info(String msg)` Log an INFO message.
    `void` | `info(String message, Object param)`
    `void` | `info(String message, Object[] params)`
    `void` | `info(String sourceClass, String sourceMethod, String msg)` Log a INFO message, with no arguments.
    `void` | `info(String sourceClass, String sourceMethod, String msg, Object param1)` Log a INFO message, with one object parameter.
    `void` | `info(String sourceClass, String sourceMethod, String msg, Object[] params)` Log a INFO message, with an array of object arguments.
    `void` | `info(String message, Throwable t)`
    `void` | `info(Throwable t)`
    `boolean` | `isConfig()` Returns true if config messages should be logged.
    `boolean` | `isFine()` Returns true if fine messages should be logged.
    `boolean` | `isFiner()` Returns true if finer messages should be logged.
    `boolean` | `isFinest()` Returns true if finest messages should be logged.
    `boolean` | `isInfo()` Returns true if info messages should be logged.
    `boolean` | `isLoggable(Level level)` Check if a message of the given level would actually be logged by this logger.
    `boolean` | `isSevere()` Returns true if severe messages should be logged.
    `boolean` | `isWarning()` Returns true if warning messages should be logged.
    `void` | `log(Level level, String msg)` Log a message, with no arguments.
    `void` | `log(Level level, String msg, Object param1)` Log a message, with one object parameter.
    `void` | `log(Level level, String msg, Object[] params)` Log a message, with an array of object arguments.
    `void` | `log(Level level, String msg, Throwable thrown)` Log a message, with associated Throwable information.
    `void` | `log(LogRecord record)` Log a LogRecord.
    `void` | `log(String msg)` Log a message, with no arguments.
    `void` | `logp(Level level, String sourceClass, String sourceMethod, String msg)` Log a message, specifying source class and method, with no arguments.
    `void` | `logp(Level level, String sourceClass, String sourceMethod, String msg, Object param1)` Log a message, specifying source class and method, with a single object parameter to the log message.
    `void` | `logp(Level level, String sourceClass, String sourceMethod, String msg, Object[] params)` Log a message, specifying source class and method, with an array of object arguments.
    `void` | `logp(Level level, String sourceClass, String sourceMethod, String msg, Object params1, Object params2, Object params3)` Log a message, with an list of object arguments.
    `void` | `logp(Level level, String sourceClass, String sourceMethod, String msg, Throwable thrown)` Log a message, specifying source class and method, with associated Throwable information.
    `void` | `logrb(Level level, String sourceClass, String sourceMethod, String bundleName, String msg)` Log a message, specifying source class, method, and resource bundle name with no arguments.
    `void` | `logrb(Level level, String sourceClass, String sourceMethod, String bundleName, String msg, Object param1)` Log a message, specifying source class, method, and resource bundle name, with a single object parameter to the log message.
    `void` | `logrb(Level level, String sourceClass, String sourceMethod, String bundleName, String msg, Object[] params)` Log a message, specifying source class, method, and resource bundle name, with an array of object arguments.
    `void` | `logrb(Level level, String sourceClass, String sourceMethod, String bundleName, String msg, Throwable thrown)` Log a message, specifying source class, method, and resource bundle name, with associated Throwable information.
    `void` | `removeHandler(Handler handler)` Remove a log Handler.
    `void` | `setLevel(Level newLevel)` Set the log level specifying which message levels will be logged by this logger.
    `void` | `setParent(Logger parent)` Set the parent for this Logger.
    `void` | `setUseParentHandlers(boolean useParentHandlers)` Specify whether or not this logger should send its output to it's parent Logger.
    `void` | `severe(String msg)` Log a SEVERE message.
    `void` | `severe(String message, Object param)`
    `void` | `severe(String message, Object[] params)`
    `void` | `severe(String sourceClass, String sourceMethod, String msg)` Log a SEVERE message, with no arguments.
    `void` | `severe(String sourceClass, String sourceMethod, String msg, Object param1)` Log a SEVERE message, with one object parameter.
    `void` | `severe(String sourceClass, String sourceMethod, String msg, Object[] params)` Log a SEVERE message, with an array of object arguments.
    `void` | `severe(String message, Throwable t)`
    `void` | `severe(Throwable t)`
    `void` | `throwing(Level level, String sourceClass, String sourceMethod, Throwable thrown)` Log throwing an exception.
    `void` | `throwing(String sourceClass, String sourceMethod, Throwable thrown)` Log throwing an exception.
    `void` | `warning(String msg)` Log a WARNING message.
    `void` | `warning(String message, Object param)`
    `void` | `warning(String message, Object[] params)`
    `void` | `warning(String sourceClass, String sourceMethod, String msg)` Log a WARNING message, with no arguments.
    `void` | `warning(String sourceClass, String sourceMethod, String msg, Object param1)` Log a WARNING message, with one object parameter.
    `void` | `warning(String sourceClass, String sourceMethod, String msg, Object[] params)` Log a WARNING message, with an array of object arguments.
    `void` | `warning(String message, Throwable t)`
    `void` | `warning(Throwable t)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### getLogger

          public Logger getLogger()

      Get the Java logger from an Trinidad Logger.
      Returns:
        a java Logger instance

    - #### createTrinidadLogger

          public static TrinidadLogger createTrinidadLogger(Class<?> c)

      Find or create a logger for a named subsystem. If a logger has already been created with the given name it is returned. Otherwise a new logger is created.

      If a new logger is created its log level will be configured based on the LogManager configuration and it will configured to also send logging output to its parent's handlers. It will be registered in the LogManager global namespace.

      Parameters:
        `c` - A class instance for the logger.
      Returns:
        a suitable Logger

    - #### createTrinidadLogger

          public static TrinidadLogger createTrinidadLogger(Class<?> c,
                                            String resourceBundleName)

      Find or create a logger for a named subsystem. If a logger has already been created with the given name it is returned. Otherwise a new logger is created.

      If a new logger is created its log level will be configured based on the LogManager configuration and it will configured to also send logging output to its parent's handlers. It will be registered in the LogManager global namespace.

      Parameters:
        `c` - A class instance for the logger.
        `resourceBundleName` - name of ResourceBundle to be used for localizing messages for this logger.
      Returns:
        a suitable Logger

    - #### createTrinidadLogger

          public static TrinidadLogger createTrinidadLogger(Package p)

      Find or create a logger for a named subsystem. If a logger has already been created with the given name it is returned. Otherwise a new logger is created.

      If a new logger is created its log level will be configured based on the LogManager configuration and it will configured to also send logging output to its parent's handlers. It will be registered in the LogManager global namespace.

      Parameters:
        `p` - A Package instance for the logger.
      Returns:
        a suitable Logger

    - #### createTrinidadLogger

          public static TrinidadLogger createTrinidadLogger(Package p,
                                            String resourceBundleName)

      Find or create a logger for a named subsystem. If a logger has already been created with the given name it is returned. Otherwise a new logger is created.

      If a new logger is created its log level will be configured based on the LogManager configuration and it will configured to also send logging output to its parent's handlers. It will be registered in the LogManager global namespace.

      Parameters:
        `p` - A Package instance for the logger.
        `resourceBundleName` - name of ResourceBundle to be used for localizing messages for this logger.
      Returns:
        a suitable Logger

    - #### getAnonymousLogger

          public static TrinidadLogger getAnonymousLogger()

      Create an anonymous Logger. The newly created Logger is not registered in the LogManager namespace. There will be no access checks on updates to the logger.

      This factory method is primarily intended for use from applets. Because the resulting Logger is anonymous it can be kept private by the creating class. This removes the need for normal security checks, which in turn allows untrusted applet code to update the control state of the Logger. For example an applet can do a setLevel or an addHandler on an anonymous Logger.

      Even although the new logger is anonymous, it is configured to have the root logger ("") as its parent. This means that by default it inherits its effective level and handlers from the root logger.

      Returns:
        a newly created private Logger

    - #### getAnonymousLogger

          public static TrinidadLogger getAnonymousLogger(String resourceBundleName)

      Create an anonymous Logger. The newly created Logger is not registered in the LogManager namespace. There will be no access checks on updates to the logger.

      This factory method is primarily intended for use from applets. Because the resulting Logger is anonymous it can be kept private by the creating class. This removes the need for normal security checks, which in turn allows untrusted applet code to update the control state of the Logger. For example an applet can do a setLevel or an addHandler on an anonymous Logger.

      Even although the new logger is anonymous, it is configured to have the root logger ("") as its parent. This means that by default it inherits its effective level and handlers from the root logger.

      Parameters:
        `resourceBundleName` - name of ResourceBundle to be used for localizing messages for this logger.
      Returns:
        a newly created private Logger
      Throws:
        `MissingResourceException` - if the named ResourceBundle cannot be found.

    - #### log

          public void log(LogRecord record)

      Log a LogRecord.

      All the other logging methods in this class call through this method to actually perform any logging. Subclasses can override this single method to capture all log activity.

      Parameters:
        `record` - the LogRecord to be published

    - #### log

          public void log(String msg)

      Log a message, with no arguments.

      If the logger is currently enabled for the given message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `msg` - The string message (or a key in the message catalog)

    - #### log

          public void log(Level level,
                 String msg)

      Log a message, with no arguments.

      If the logger is currently enabled for the given message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `msg` - The string message (or a key in the message catalog)

    - #### log

          public void log(Level level,
                 String msg,
                 Object param1)

      Log a message, with one object parameter.

      If the logger is currently enabled for the given message level then a corresponding LogRecord is created and forwarded to all the registered output Handler objects.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `msg` - The string message (or a key in the message catalog)
        `param1` - parameter to the message

    - #### log

          public void log(Level level,
                 String msg,
                 Object[] params)

      Log a message, with an array of object arguments.

      If the logger is currently enabled for the given message level then a corresponding LogRecord is created and forwarded to all the registered output Handler objects.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `msg` - The string message (or a key in the message catalog)
        `params` - array of parameters to the message

    - #### log

          public void log(Level level,
                 String msg,
                 Throwable thrown)

      Log a message, with associated Throwable information.

      If the logger is currently enabled for the given message level then the given arguments are stored in a LogRecord which is forwarded to all registered output handlers.

      Note that the thrown argument is stored in the LogRecord thrown property, rather than the LogRecord parameters property. Thus is it processed specially by output Formatters and is not treated as a formatting parameter to the LogRecord message property.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `msg` - The string message (or a key in the message catalog)
        `thrown` - Throwable associated with log message.

    - #### logp

          public void logp(Level level,
                  String sourceClass,
                  String sourceMethod,
                  String msg)

      Log a message, specifying source class and method, with no arguments.

      If the logger is currently enabled for the given message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that issued the logging request
        `msg` - The string message (or a key in the message catalog)

    - #### logp

          public void logp(Level level,
                  String sourceClass,
                  String sourceMethod,
                  String msg,
                  Object param1)

      Log a message, specifying source class and method, with a single object parameter to the log message.

      If the logger is currently enabled for the given message level then a corresponding LogRecord is created and forwarded to all the registered output Handler objects.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that issued the logging request
        `msg` - The string message (or a key in the message catalog)
        `param1` - Parameter to the log message.

    - #### logp

          public void logp(Level level,
                  String sourceClass,
                  String sourceMethod,
                  String msg,
                  Object[] params)

      Log a message, specifying source class and method, with an array of object arguments.

      If the logger is currently enabled for the given message level then a corresponding LogRecord is created and forwarded to all the registered output Handler objects.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that issued the logging request
        `msg` - The string message (or a key in the message catalog)
        `params` - Array of parameters to the message

    - #### logp

          public void logp(Level level,
                  String sourceClass,
                  String sourceMethod,
                  String msg,
                  Throwable thrown)

      Log a message, specifying source class and method, with associated Throwable information.

      If the logger is currently enabled for the given message level then the given arguments are stored in a LogRecord which is forwarded to all registered output handlers.

      Note that the thrown argument is stored in the LogRecord thrown property, rather than the LogRecord parameters property. Thus is it processed specially by output Formatters and is not treated as a formatting parameter to the LogRecord message property.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that issued the logging request
        `msg` - The string message (or a key in the message catalog)
        `thrown` - Throwable associated with log message.

    - #### logrb

          public void logrb(Level level,
                   String sourceClass,
                   String sourceMethod,
                   String bundleName,
                   String msg)

      Log a message, specifying source class, method, and resource bundle name with no arguments.

      If the logger is currently enabled for the given message level then the given message is forwarded to all the registered output Handler objects.

      The msg string is localized using the named resource bundle. If the resource bundle name is null, then the msg string is not localized.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that issued the logging request
        `bundleName` - name of resource bundle to localize msg
        `msg` - The string message (or a key in the message catalog)
      Throws:
        `MissingResourceException` - if no suitable ResourceBundle can be found.

    - #### logrb

          public void logrb(Level level,
                   String sourceClass,
                   String sourceMethod,
                   String bundleName,
                   String msg,
                   Object param1)

      Log a message, specifying source class, method, and resource bundle name, with a single object parameter to the log message.

      If the logger is currently enabled for the given message level then a corresponding LogRecord is created and forwarded to all the registered output Handler objects.

      The msg string is localized using the named resource bundle. If the resource bundle name is null, then the msg string is not localized.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that issued the logging request
        `bundleName` - name of resource bundle to localize msg
        `msg` - The string message (or a key in the message catalog)
        `param1` - Parameter to the log message.
      Throws:
        `MissingResourceException` - if no suitable ResourceBundle can be found.

    - #### logrb

          public void logrb(Level level,
                   String sourceClass,
                   String sourceMethod,
                   String bundleName,
                   String msg,
                   Object[] params)

      Log a message, specifying source class, method, and resource bundle name, with an array of object arguments.

      If the logger is currently enabled for the given message level then a corresponding LogRecord is created and forwarded to all the registered output Handler objects.

      The msg string is localized using the named resource bundle. If the resource bundle name is null, then the msg string is not localized.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that issued the logging request
        `bundleName` - name of resource bundle to localize msg
        `msg` - The string message (or a key in the message catalog)
        `params` - Array of parameters to the message
      Throws:
        `MissingResourceException` - if no suitable ResourceBundle can be found.

    - #### logrb

          public void logrb(Level level,
                   String sourceClass,
                   String sourceMethod,
                   String bundleName,
                   String msg,
                   Throwable thrown)

      Log a message, specifying source class, method, and resource bundle name, with associated Throwable information.

      If the logger is currently enabled for the given message level then the given arguments are stored in a LogRecord which is forwarded to all registered output handlers.

      The msg string is localized using the named resource bundle. If the resource bundle name is null, then the msg string is not localized.

      Note that the thrown argument is stored in the LogRecord thrown property, rather than the LogRecord parameters property. Thus is it processed specially by output Formatters and is not treated as a formatting parameter to the LogRecord message property.

      Parameters:
        `level` - One of the message level identifiers, e.g. SEVERE
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that issued the logging request
        `bundleName` - name of resource bundle to localize msg
        `msg` - The string message (or a key in the message catalog)
        `thrown` - Throwable associated with log message.
      Throws:
        `MissingResourceException` - if no suitable ResourceBundle can be found.

    - #### entering

          public void entering(String sourceClass,
                      String sourceMethod)

      Log a method entry.

      This is a convenience method that can be used to log entry to a method. A LogRecord with message "ENTRY", log level FINER, and the given sourceMethod and sourceClass is logged.

      Parameters:
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that is being entered

    - #### entering

          public void entering(String sourceClass,
                      String sourceMethod,
                      Object param1)

      Log a method entry, with one parameter.

      This is a convenience method that can be used to log entry to a method. A LogRecord with message "ENTRY {0}", log level FINER, and the given sourceMethod, sourceClass, and parameter is logged.

      Parameters:
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that is being entered
        `param1` - parameter to the method being entered

    - #### entering

          public void entering(String sourceClass,
                      String sourceMethod,
                      Object[] params)

      Log a method entry, with an array of parameters.

      This is a convenience method that can be used to log entry to a method. A LogRecord with message "ENTRY" (followed by a format {N} indicator for each entry in the parameter array), log level FINER, and the given sourceMethod, sourceClass, and parameters is logged.

      Parameters:
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of method that is being entered
        `params` - array of parameters to the method being entered

    - #### exiting

          public void exiting(String sourceClass,
                     String sourceMethod)

      Log a method return.

      This is a convenience method that can be used to log returning from a method. A LogRecord with message "RETURN", log level FINER, and the given sourceMethod and sourceClass is logged.

      Parameters:
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of the method

    - #### exiting

          public void exiting(String sourceClass,
                     String sourceMethod,
                     Object result)

      Log a method return, with result object.

      This is a convenience method that can be used to log returning from a method. A LogRecord with message "RETURN {0}", log level FINER, and the gives sourceMethod, sourceClass, and result object is logged.

      Parameters:
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of the method
        `result` - Object that is being returned

    - #### throwing

          public void throwing(String sourceClass,
                      String sourceMethod,
                      Throwable thrown)

      Log throwing an exception.

      This is a convenience method to log that a method is terminating by throwing an exception. The logging is done using the FINER level.

      If the logger is currently enabled for the given message level then the given arguments are stored in a LogRecord which is forwarded to all registered output handlers. The LogRecord's message is set to "THROW".

      Note that the thrown argument is stored in the LogRecord thrown property, rather than the LogRecord parameters property. Thus is it processed specially by output Formatters and is not treated as a formatting parameter to the LogRecord message property.

      Parameters:
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of the method.
        `thrown` - The Throwable that is being thrown.

    - #### severe

          public void severe(String msg)

      Log a SEVERE message.

      If the logger is currently enabled for the SEVERE message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `msg` - The string message (or a key in the message catalog)

    - #### warning

          public void warning(String msg)

      Log a WARNING message.

      If the logger is currently enabled for the WARNING message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `msg` - The string message (or a key in the message catalog)

    - #### info

          public void info(String msg)

      Log an INFO message.

      If the logger is currently enabled for the INFO message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `msg` - The string message (or a key in the message catalog)

    - #### config

          public void config(String msg)

      Log a CONFIG message.

      If the logger is currently enabled for the CONFIG message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `msg` - The string message (or a key in the message catalog)

    - #### fine

          public void fine(String msg)

      Log a FINE message.

      If the logger is currently enabled for the FINE message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `msg` - The string message (or a key in the message catalog)

    - #### finer

          public void finer(String msg)

      Log a FINER message.

      If the logger is currently enabled for the FINER message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `msg` - The string message (or a key in the message catalog)

    - #### finest

          public void finest(String msg)

      Log a FINEST message.

      If the logger is currently enabled for the FINEST message level then the given message is forwarded to all the registered output Handler objects.

      Parameters:
        `msg` - The string message (or a key in the message catalog)

    - #### throwing

          public void throwing(Level level,
                      String sourceClass,
                      String sourceMethod,
                      Throwable thrown)

      Log throwing an exception. Comparing to Java Logging function Logger.throwing(sourceClass, sourceMethod, thrown) this function takes one more parameter "level" so that developers can specify the logging level of an exception. Developers should pass value for the "level" parameter using following convention,

      Level.SEVERE -- Serious exceptions or error conditions such that an application can no longer run.

      Level.WARNING -- Exceptions or errors that are not fatal, but an application will run with some problems.

      Parameters:
        `level` - Java Logging level
        `sourceClass` - name of class that issued the logging request
        `sourceMethod` - name of the method
        `thrown` - The Throwable that is being thrown

    - #### severe

          public void severe(String sourceClass,
                    String sourceMethod,
                    String msg)

      Log a SEVERE message, with no arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)

    - #### severe

          public void severe(String sourceClass,
                    String sourceMethod,
                    String msg,
                    Object param1)

      Log a SEVERE message, with one object parameter.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `param1` - a parameter to the message

    - #### severe

          public void severe(String sourceClass,
                    String sourceMethod,
                    String msg,
                    Object[] params)

      Log a SEVERE message, with an array of object arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `params` - an array of parameters to the message

    - #### warning

          public void warning(String sourceClass,
                     String sourceMethod,
                     String msg)

      Log a WARNING message, with no arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)

    - #### warning

          public void warning(String sourceClass,
                     String sourceMethod,
                     String msg,
                     Object param1)

      Log a WARNING message, with one object parameter.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `param1` - a parameter to the message

    - #### warning

          public void warning(String sourceClass,
                     String sourceMethod,
                     String msg,
                     Object[] params)

      Log a WARNING message, with an array of object arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `params` - an array of parameters to the message

    - #### info

          public void info(String sourceClass,
                  String sourceMethod,
                  String msg)

      Log a INFO message, with no arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)

    - #### info

          public void info(String sourceClass,
                  String sourceMethod,
                  String msg,
                  Object param1)

      Log a INFO message, with one object parameter.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `param1` - a parameter to the message

    - #### info

          public void info(String sourceClass,
                  String sourceMethod,
                  String msg,
                  Object[] params)

      Log a INFO message, with an array of object arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `params` - an array of parameters to the message

    - #### config

          public void config(String sourceClass,
                    String sourceMethod,
                    String msg)

      Log a CONFIG message, with no arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)

    - #### config

          public void config(String sourceClass,
                    String sourceMethod,
                    String msg,
                    Object param1)

      Log a CONFIG message, with one object parameter.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `param1` - a parameter to the message

    - #### config

          public void config(String sourceClass,
                    String sourceMethod,
                    String msg,
                    Object[] params)

      Log a CONFIG message, with an array of object arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `params` - an array of parameters to the message

    - #### fine

          public void fine(String sourceClass,
                  String sourceMethod,
                  String msg)

      Log a FINE message, with no arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)

    - #### fine

          public void fine(String sourceClass,
                  String sourceMethod,
                  String msg,
                  Object param1)

      Log a FINE message, with one object parameter.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `param1` - a parameter to the message

    - #### fine

          public void fine(String sourceClass,
                  String sourceMethod,
                  String msg,
                  Object[] params)

      Log a FINE message, with an array of object arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `params` - an array of parameters to the message

    - #### finer

          public void finer(String sourceClass,
                   String sourceMethod,
                   String msg)

      Log a FINER message, with no arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)

    - #### finer

          public void finer(String sourceClass,
                   String sourceMethod,
                   String msg,
                   Object param1)

      Log a FINER message, with one object parameter.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `param1` - a parameter to the message

    - #### finer

          public void finer(String sourceClass,
                   String sourceMethod,
                   String msg,
                   Object[] params)

      Log a FINER message, with an array of object arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `params` - an array of parameters to the message

    - #### finest

          public void finest(String sourceClass,
                    String sourceMethod,
                    String msg)

      Log a FINEST message, with no arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)

    - #### finest

          public void finest(String sourceClass,
                    String sourceMethod,
                    String msg,
                    Object param1)

      Log a FINEST message, with one object parameter.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `param1` - a parameter to the message

    - #### finest

          public void finest(String sourceClass,
                    String sourceMethod,
                    String msg,
                    Object[] params)

      Log a FINEST message, with an array of object arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `params` - an array of parameters to the message

    - #### logp

          public void logp(Level level,
                  String sourceClass,
                  String sourceMethod,
                  String msg,
                  Object params1,
                  Object params2,
                  Object params3)

      Log a message, with an list of object arguments.

      The message is forwarded to appropriate Java Logger objects.

      Parameters:
        `sourceClass` - the name of the class that issued the logging request
        `sourceMethod` - the name of the method that issued the logging request
        `msg` - the string message (or a key in the resource bundle)
        `params1` - Parameter 1 to the log message
        `params2` - Parameter 2 to the log message
        `params3` - Parameter 3 to the log message

    - #### setLevel

          public void setLevel(Level newLevel)
                        throws SecurityException

      Set the log level specifying which message levels will be logged by this logger. Message levels lower than this value will be discarded. The level value Level.OFF can be used to turn off logging.

      If the new level is null, it means that this node should inherit its level from its nearest ancestor with a specific (non-null) level value.

      Parameters:
        `newLevel` - the new value for the log level (may be null)
      Throws:
        `SecurityException` - if a security manager exists and if the caller does not have LoggingPermission("control").

    - #### getLevel

          public Level getLevel()

      Get the log Level that has been specified for this Logger. The result may be null, which means that this logger's effective level will be inherited from its parent.
      Returns:
        this Logger's level

    - #### isLoggable

          public boolean isLoggable(Level level)

      Check if a message of the given level would actually be logged by this logger. This check is based on the Loggers effective level, which may be inherited from its parent.
      Parameters:
        `level` - a message logging level
      Returns:
        true if the given message level is currently being logged.

    - #### getName

          public String getName()

      Get the name for this logger.
      Returns:
        logger name. Will be null for anonymous Loggers.

    - #### addHandler

          public void addHandler(Handler handler)
                          throws SecurityException

      Add a log Handler to receive logging messages.

      By default, Loggers also send their output to their parent logger. Typically the root Logger is configured with a set of Handlers that essentially act as default handlers for all loggers.

      Parameters:
        `handler` - a logging Handler
      Throws:
        `SecurityException` - if a security manager exists and if the caller does not have LoggingPermission("control").

    - #### removeHandler

          public void removeHandler(Handler handler)
                             throws SecurityException

      Remove a log Handler.

      Returns silently if the given Handler is not found.

      Parameters:
        `handler` - a logging Handler
      Throws:
        `SecurityException` - if a security manager exists and if the caller does not have LoggingPermission("control").

    - #### getHandlers

          public Handler[] getHandlers()

      Get the Handlers associated with this logger.

      Returns:
        an array of all registered Handlers

    - #### setUseParentHandlers

          public void setUseParentHandlers(boolean useParentHandlers)

      Specify whether or not this logger should send its output to it's parent Logger. This means that any LogRecords will also be written to the parent's Handlers, and potentially to its parent, recursively up the namespace.
      Parameters:
        `useParentHandlers` - true if output is to be sent to the logger's parent.
      Throws:
        `SecurityException` - if a security manager exists and if the caller does not have LoggingPermission("control").

    - #### getUseParentHandlers

          public boolean getUseParentHandlers()

      Discover whether or not this logger is sending its output to its parent logger.
      Returns:
        true if output is to be sent to the logger's parent

    - #### getParent

          public Logger getParent()

      Return the parent for this Logger.

      This method returns the nearest extant parent in the namespace. Thus if a Logger is called "a.b.c.d", and a Logger called "a.b" has been created but no logger "a.b.c" exists, then a call of getParent on the Logger "a.b.c.d" will return the Logger "a.b".

      The result will be null if it is called on the root Logger in the namespace.

      Returns:
        nearest existing parent Logger

    - #### setParent

          public void setParent(Logger parent)

      Set the parent for this Logger. This method is used by the LogManager to update a Logger when the namespace changes.

      It should not be called from application code.

      Parameters:
        `parent` - the new parent logger
      Throws:
        `SecurityException` - if a security manager exists and if the caller does not have LoggingPermission("control").

    - #### severe

          public void severe(Throwable t)

    - #### severe

          public void severe(String message,
                    Throwable t)

    - #### severe

          public void severe(String message,
                    Object param)

    - #### severe

          public void severe(String message,
                    Object[] params)

    - #### warning

          public void warning(Throwable t)

    - #### warning

          public void warning(String message,
                     Throwable t)

    - #### warning

          public void warning(String message,
                     Object param)

    - #### warning

          public void warning(String message,
                     Object[] params)

    - #### info

          public void info(Throwable t)

    - #### info

          public void info(String message,
                  Throwable t)

    - #### info

          public void info(String message,
                  Object param)

    - #### info

          public void info(String message,
                  Object[] params)

    - #### fine

          public void fine(Throwable t)

    - #### fine

          public void fine(String message,
                  Throwable t)

    - #### fine

          public void fine(String message,
                  Object param)

    - #### fine

          public void fine(String message,
                  Object[] params)

    - #### finer

          public void finer(Throwable t)

    - #### finer

          public void finer(String message,
                   Throwable t)

    - #### finer

          public void finer(String message,
                   Object param)

    - #### finer

          public void finer(String message,
                   Object[] params)

    - #### finest

          public void finest(Throwable t)

    - #### finest

          public void finest(String message,
                    Throwable t)

    - #### finest

          public void finest(String message,
                    Object param)

    - #### finest

          public void finest(String message,
                    Object[] params)

    - #### isSevere

          public boolean isSevere()

      Returns true if severe messages should be logged.

    - #### isWarning

          public boolean isWarning()

      Returns true if warning messages should be logged.

    - #### isInfo

          public boolean isInfo()

      Returns true if info messages should be logged.

    - #### isConfig

          public boolean isConfig()

      Returns true if config messages should be logged.

    - #### isFine

          public boolean isFine()

      Returns true if fine messages should be logged.

    - #### isFiner

          public boolean isFiner()

      Returns true if finer messages should be logged.

    - #### isFinest

          public boolean isFinest()

      Returns true if finest messages should be logged.

    - #### getMessage

          public String getMessage(String key)

      Returns message string in default locale

    - #### getMessage

          public String getMessage(String key,
                          Object[] params)

      Returns formated string in default locale

    - #### getMessage

          public String getMessage(String key,
                          Object param)

      Returns formated string in default locale

Copyright © 2001-2017 The Apache Software Foundation. All Rights Reserved.